Subject: bug#60845: 30.0.50; [PATCH] Add tests for Eshell interactive completion (and fix a bug in it)

From: Stefan Monnier <[email-masked]>
Date: Mon, 30 Jan 2023 09:54:09 -0500

>>> The third patch in this series fixes this for the Eshell side, so we
>>> could probably remove the workaround in pcomplete.el for Emacs 30.
>
> Stefan, do you have any thoughts on these changes, especially the third
> patch? I did a bit of tinkering with pcomplete functions, and I think it
> should be ok for the Eshell side of things. Eshell-specific pcomplete
> functions can get the real value if they need by examining the
> 'pcomplete-arg-value' string property.
>
> For pcomplete functions that aren't Eshell-specific, they'll always get the
> string form of arguments by default, so things should Just Work there.

It sounds good to me, but I'm definitely not well versed in this aspect
of the interaction between Eshell and Pcomplete (more specifically,
this is a part of their interaction which I find quite tricky), so it's
good that you add corresponding regression tests.

        Stefan